;+
; NAME: ccsds_packet__define.pro
;
; PURPOSE: Definition of the general ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

function ccsds_packet::read_ccsds_packet_header, lu
;  print, 'ccsds_packet::read_ccsds_packet_header'
  self->trace, 'ccsds_packet::read_ccsds_packet_header'
  on_ioerror, bad_hdr_rd

  hdr = self.ccsds_header
  readu, lu, hdr
;;;;;;;;;  if self.debug then print, hdr
  
  self.ccsds_header = hdr
  return, 0
;    return, n_elements(hdr)

  bad_hdr_rd:
  if eof(lu) then begin
     print, 'ccsds_packet::read_ccsds_packet_header : END OF FILE found'
     ;self->set_errors, 2, !SYSERROR, !ERR_STRING
     ; GDL
     self->set_errors, 2, 1, !ERR_STRING
     return, 1
  endif
  ;self->set_errors, 1, !SYSERROR, !ERR_STRING
  ; GDL
  self->set_errors, 2, 2, !ERR_STRING
  print, 'ccsds_packet::read_ccsds_packet_header: bad_hdr_rd', hdr
  print, !err_string
  return, 2
end
